SystemOrganization addCategory: #'SBE-Quinto'!

SimpleSwitchMorph subclass: #SBECell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBECell methodsFor: 'as yet unclassified' stamp: 'DFL 10/3/2013 09:47'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff! !

!SBECell methodsFor: 'as yet unclassified' stamp: 'DFL 10/3/2013 09:55'!
mouseAction: aBlock
	^ mouseAction := aBlock! !

!SBECell methodsFor: 'as yet unclassified' stamp: 'DFL 10/3/2013 09:56'!
mouseUp: anEvent
	mouseAction value! !

BorderedMorph subclass: #SBEGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SBE-Quinto'!

!SBEGame methodsFor: 'as yet unclassified' stamp: 'DFL 10/3/2013 09:51'!
cellsPerSide
	"The number of cells along each side of the game"
	^ 10! !

!SBEGame methodsFor: 'as yet unclassified' stamp: 'DFL 10/3/2013 09:48'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := SBECell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n) @(height*n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].! !

!SBEGame methodsFor: 'as yet unclassified' stamp: 'DFL 10/3/2013 10:02'!
newCellAt: i at: j
	| c origin |
	c := SBECell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^ c! !

!SBEGame methodsFor: 'as yet unclassified' stamp: 'DFL 10/3/2013 09:54'!
toggleNeighboursOfCellAt: i at: j
	(i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
	(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
	(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState].! !
